import {
	login,
	logout,
	getInfo
} from '@/api/login'
import {
	getToken,
	setToken,
	removeToken
} from '@/utils/auth'

const user = {
	state: {
		token: getToken(),
		userInfo: '',
		name: '',
		avatar: '',
		roles: [],
		permissions: []
	},

	mutations: {
		SET_TOKEN: (state, token) => {
			state.token = token
		},
		SET_USERINFO: (state, userInfo) => {
			state.userInfo = userInfo
		},
		SET_NAME: (state, name) => {
			state.name = name
		},
		SET_AVATAR: (state, avatar) => {
			state.avatar = avatar
		},
		SET_ROLES: (state, roles) => {
			state.roles = roles
		},
		SET_PERMISSIONS: (state, permissions) => {
			state.permissions = permissions
		}
	},

	actions: {
		// 登录
		Login({
			commit
		}, userInfo) {
			console.log('开始登录')
			return new Promise((resolve, reject) => {
				login().then(res => {
					setToken(res.data.token)
					commit('SET_TOKEN', res.data.token)
					resolve(res)
				}).catch(error => {
					reject(error)
				})
			})
		},

		// 获取用户信息
		GetInfo({
			commit,
			state
		}) {
			return new Promise((resolve, reject) => {
				getInfo().then(res => {
					commit('SET_USERINFO', res.data.student)
					resolve(res)
				}).catch(error => {
					reject(error)
				})
			})
		},

		// 退出系统
		// LogOut({ commit, state }) {
		//   return new Promise((resolve, reject) => {
		//     logout(state.token).then(() => {
		//       commit('SET_TOKEN', '')
		//       commit('SET_ROLES', [])
		//       commit('SET_PERMISSIONS', [])
		//       removeToken()
		//       resolve()
		//     }).catch(error => {
		//       reject(error)
		//     })
		//   })
		// },

		// 前端 登出
		// FedLogOut({ commit }) {
		//   return new Promise(resolve => {
		//     commit('SET_TOKEN', '')
		//     removeToken()
		//     resolve()
		//   })
		// }
	}
}

export default user
